/************************************************************************/
/*    2007.12.24 LZX Created                                            */
/*                                                                      */
/*                                                                      */
/************************************************************************/

#include "stdafx.h"
#include "asynsocket\AsyncSocketEx.h"
#include "PRCTcpServer.h"
#include "ProxyReceptionCentre.h"
#include "GlobalProxy.h"
#include "ProxyLog.h"
#include "ProxySettings.h"


CPRCTcpServer::CPRCTcpServer(CProxyReceptionCentre *pPRC)
	: CPRCXServer(pPRC)
	, m_ProxyTaskMgr(pPRC)
{
}

CPRCTcpServer::~CPRCTcpServer(void)
{
}

BOOL CPRCTcpServer::StartupServer()
{
	UINT nSocketPort = INADDR_ANY;

#ifdef _DEBUG
	//nSocketPort = 248;
#endif
	if(!Create(nSocketPort))
		return FALSE;

	int socketbufsize=1024*16;
	SetSockOpt(SO_RCVBUF, &socketbufsize,sizeof(socketbufsize));

	if(!Listen())
		return FALSE;

	_SockAddr tcpaddr;
	INT addlen = sizeof(tcpaddr);
	if(!GetSockName(&tcpaddr, &addlen))
	{
		Close();
		return FALSE;
	}

	PrintText("PRCTcpServer ˿: %d\r\n", tcpaddr.GetPort());

	return TRUE;
}


BOOL CPRCTcpServer::ShutdownServer()
{
	m_ProxyTaskMgr.RemoveAllTasks();
	Close();

	PrintText("PRCTcpServer ر.\r\n");
	return TRUE;
}

void CPRCTcpServer::OnAccept(int nErrorCode)
{
	_SockAddr sa;
	int len = sizeof(sa);
	SOCKET sClient = accept(m_SocketData.hSocket, &sa, &len);
	if (sClient == INVALID_SOCKET)
		return;

	//CHookWinsock صһʱὫ׽ַֺǼǵPRC,
	//ͨPRCĽӿGetClientInfoõԭĸӵַ,
	//GetClientInfoڲͨܵ׽ֲѯ(getpeername)ӵԭipͶ˿ڣPRCǼǵвƥĵַ˿Ϣ.
	PRCClient PRCC;
	if(!m_pPRC->GetClientInfo(sClient, &PRCC, TRUE))
	{
		PrintText("PRCTcpServerܵһ޷.\r\n");
		closesocket(sClient);
		return;
	}
	PRCC.sAccept = sClient;

	DWORD nIP = PRCC.dstAddr.GetdwIP();
	const BYTE* pucIP = (BYTE*)&nIP;

	ProxyInfo pisetting;
	memset(&pisetting, 0, sizeof(pisetting));

	IProxySettings *pProxySettings = m_pGlobalProxy->GetSettingsInstance();
	if(!pProxySettings->GetProxyInfo(&PRCC, &pisetting))
	{
		PrintText("ȡϢʧ\r\n");
		closesocket(sClient);
		return;
	}

	if(!m_ProxyTaskMgr.OnNewTask(sClient, &PRCC, &pisetting))
	{
		PrintText("һʧ. PID: %d, %u.%u.%u.%u:%d, : %s:%d\r\n", PRCC.dwPid, pucIP[0], pucIP[1], pucIP[2], pucIP[3], PRCC.dstAddr.GetPort(), PRCC.szDomainName, PRCC.dstAddr.GetPort());
		closesocket(sClient);
		return;
	}

	LogNewProxyTask(&PRCC);

	if(PRCC.IsDNValid())
	{
		PrintText("PID: %d, connect to: %s:%d\r\n", PRCC.dwPid, PRCC.szDomainName, PRCC.dstAddr.GetPort());
	}else
	{
		PrintText("PID: %d, connect to: %u.%u.%u.%u:%d\r\n", PRCC.dwPid, pucIP[0], pucIP[1], pucIP[2], pucIP[3], PRCC.dstAddr.GetPort());
	}


}

IProxyTaskMgr *CPRCTcpServer::GetPTMInstance()
{
	return &m_ProxyTaskMgr;
}