/************************************************************************/
/*    2007.12.24 LZX Created                                            */
/*                                                                      */
/*                                                                      */
/************************************************************************/

#include "stdafx.h"
#include "TcpProxyTask.h"
#include "ProxyTaskMgr.h"
#include "PRCTcpPeer.h"

CTcpProxyTask::CTcpProxyTask(CProxyTCPTaskMgr *pTaskmgr)
{
	m_pTaskmgr = pTaskmgr;

	m_pClient = NULL;
	m_pServer = NULL;
}

CTcpProxyTask::~CTcpProxyTask(void)
{
	EndTask();
}

/*
1sClient  PRC Server acceptĿͻˣҲǸHookغתPRC
2lpPRCClient ΪԭĵַϢ
3lpProxyInfo ΪGlobalProxyõĴϢ

CTcpProxyTask ֻǸ𴴽CPRCTcpPeerֱΪm_pClientm_pServerһ

m_pServerͨ(lpProxyInfo)ԭĵַ(lpPRCClient)Ӻ m_pClient дת

================
̣

һconnect -> HookWinsock.connect, HookWinsock¼ԭϢsocketǼǵProxyReceptionCentre (PRC), Ȼ޸ĿĵַPRC

PRC Server OnAccept յһsClientַͨϢPRCѯԭַ, GlobalProxyǰõĴϢݸCTcpProxyTask.SetTaskInfo
*/
BOOL CTcpProxyTask::SetTaskInfo(SOCKET sClient, LPPRCClient lpPRCClient, LPProxyInfo lpProxyInfo)
{
	do 
	{
		m_pClient = new CPRCTcpPeer(this);
		if(m_pClient == NULL)
			break;

		m_pServer = new CPRCTcpPeer(this);
		if(m_pServer == NULL)
			break;

		m_PRCClient = *lpPRCClient;
		m_ProxyInfo = *lpProxyInfo;
		m_pClient->SetPartner(m_pServer);
		m_pServer->SetPartner(m_pClient);

		int socketbufsize=1024*16;
		m_pServer->SetSockOpt(SO_SNDBUF, &socketbufsize,sizeof(socketbufsize));
		m_pServer->SetSockOpt(SO_RCVBUF, &socketbufsize,sizeof(socketbufsize));

		if(!m_pServer->ConnectProxy(lpPRCClient, lpProxyInfo))
			break;

		//ȲעclientĶд ȴɹ
		if(!m_pClient->Attach(sClient, FD_CLOSE))
			break;

		m_pClient->SetSockOpt(SO_SNDBUF, &socketbufsize,sizeof(socketbufsize));
		m_pClient->SetSockOpt(SO_RCVBUF, &socketbufsize,sizeof(socketbufsize));

		return TRUE;
	} while(FALSE);

	delete m_pClient;
	delete m_pServer;
	m_pClient = NULL;
	m_pServer = NULL;

	return FALSE;
}

VOID CTcpProxyTask::OnPeerClosed(CPRCTcpPeer *pPeer)
{

	if(m_pClient->GetSocketHandle() == INVALID_SOCKET && m_pServer->GetSocketHandle() == INVALID_SOCKET)
	{
		m_pTaskmgr->OnDeleteTask(this);
	}

}

VOID CTcpProxyTask::EndTask()
{
	if(m_pClient)
	{
		m_pClient->Close();
		delete m_pClient;
		m_pClient = NULL;
	}
	if(m_pServer)
	{
		m_pServer->Close();
		delete m_pServer;
		m_pServer = NULL;
	}
}
